# List Campaigns

> Source: https://truto.one/docs/api-reference/unified-ads-management-api/campaigns/list/

`GET /unified/ads/campaigns`

Resource: **Campaigns** · API: **Unified Ads Management API**

## Supported integrations

Google Ads, LinkedIn, Meta Marketing API

## Query parameters

- **`integrated_account_id`** _(string, required)_
  The ID of the integrated account to use for the request.
- **`truto_response_format`** _(string)_
  The format of the response. - `unified` returns the response with unified mappings applied. - `raw` returns the unprocessed, raw response from the remote API. - `normalized` applies the unified mappings and returns the data in a normalized format. - `stream` returns the response as a stream, which is ideal for transmitting large datasets, files, or binary data. Using streaming mode helps to efficiently handle large payloads or real-time data flows without requiring the entire data to be buffered in memory. Defaults to `unified`.
  Allowed: `unified`, `raw`, `normalized`, `stream`
- **`truto_key_by`** _(string)_
  By default the `result` attribute is an array of objects. This parameter allows you to specify a field in each `result` objects to use as key, which transforms the `result` array into an object with the array items keyed by the field. This is useful for when you want to use the result as a lookup table.
- **`truto_ignore_limit`** _(boolean)_
  Ignores the `limit` query parameter.
- **`truto_ignore_remote_data`** _(boolean)_
  Excludes the `remote_data` attribute from the response.
- **`truto_exclude_fields`** _(array<string>)_
  Array of fields to exclude from the response.
- **`remote_query`** _(object)_
  Query parameters to pass to the underlying API without any transformations. Refer [this guide](https://truto.one/docs/api-reference/overview/querying#remote-query-parameters) to see how to structure the query parameters.
- **`account_id`** _(string)_
  The unique identifier for the account.
- **`start_time`** _(string)_
  The start time for the campaign.
- **`end_time`** _(unknown)_

## Response body

- **`result`** _(array<object>)_
  List of Campaigns
  - **`id`** _(string, required)_
    The unique identifier for the campaign.
  - **`name`** _(string)_
    The name of the campaign.
  - **`status`** _(string)_
    The status of the campaign.
    Allowed: `active`, `inactive`, `draft`, `paused`, `deleted`, `archived`, `in_process`, `with_issues`, `completed`, `canceled`, `pending_deletion`
  - **`type`** _(string)_
    The type of the campaign
  - **`account_id`** _(string)_
    The unique identifier for the account.
  - **`labels`** _(array<object>)_
    The labels for the campaign.
    - **`id`** _(string)_
      The unique identifier for the label.
    - **`name`** _(string)_
      The name of the label.
  - **`objective`** _(string)_
    The objective of the campaign.
    Allowed: `app_installs`, `brand_awareness`, `conversions`, `visits`, `job_applications`, `event_responses`, `lead_generation`, `link_clicks`, `local_awareness`, `messages`, `offer_claims`, `outcome_app_promotion` (+11 more)
  - **`bid_strategy`** _(object)_
    The bid strategy for the campaign.
    - **`id`** _(string)_
      The unique identifier for the bid strategy.
    - **`name`** _(string)_
      The name of the bid strategy.
      Allowed: `lowest_cost_without_cap`, `lowest_cost_with_bid_cap`, `cost_cap`
  - **`buying_type`** _(string)_
    The buying type for the campaign.
    Allowed: `auction`, `reserved`
  - **`budget`** _(object)_
    The budget for the campaign.
    - **`id`** _(string)_
      The unique identifier for the budget.
    - **`remaining`** _(string)_
      The remaining budget for the campaign.
    - **`lifetime_max`** _(string)_
      The max budget for the campaign.
    - **`daily_max`** _(string)_
      The daily max budget for the campaign.
    - **`is_scheduling_enabled`** _(boolean)_
      Whether budget scheduling is enabled for the campaign.
    - **`is_rebalance_enabled`** _(boolean)_
      Whether budget rebalancing is enabled for the campaign.
    - **`is_shared`** _(boolean)_
      Whether the budget is shared for the campaign with other campaigns.
  - **`spend`** _(object)_
    The spend for the campaign.
    - **`max_cap`** _(string)_
      The max cap spend for the campaign.
    - **`cap_enabled`** _(boolean)_
      Whether the cap is enabled for the campaign.
  - **`primary_attribution`** _(string)_
    The primary attribution for the campaign.
  - **`special_ad_categories`** _(array<string>)_
    The special ad categories for the campaign.
  - **`special_ad_category`** _(string)_
    The special ad category for the campaign.
    Allowed: `credit`, `employment`, `housing`, `none`, `political`, `social_issues`
  - **`start_time`** _(string)_
    The start time for the campaign.
  - **`stop_time`** _(string)_
    The stop time for the campaign.
  - **`created_at`** _(string)_
    The date and time the campaign was created.
  - **`updated_at`** _(string)_
    The date and time the campaign was last updated.
  - **`remote_data`** _(object)_
    Raw data returned from the remote API call.
- **`next_cursor`** _(string)_
  The cursor to use for the next page of results. Pass this value as `next_cursor` in the query parameter in the next request to get the next page of results.

## Code examples

### curl

```bash
curl -X GET 'https://api.truto.one/unified/ads/campaigns?integrated_account_id=<integrated_account_id>' \
  -H 'Authorization: Bearer <your_api_token>' \
  -H 'Content-Type: application/json'
```

### JavaScript

```javascript
const integratedAccountId = '<integrated_account_id>';

const response = await fetch(`https://api.truto.one/unified/ads/campaigns?integrated_account_id=${integratedAccountId}`, {
  method: 'GET',
  headers: {
    'Authorization': 'Bearer <your_api_token>',
    'Content-Type': 'application/json',
  },
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

url = "https://api.truto.one/unified/ads/campaigns"
headers = {
    "Authorization": "Bearer <your_api_token>",
    "Content-Type": "application/json",
}
params = {
    "integrated_account_id": "<integrated_account_id>"
}

response = requests.get(url, headers=headers, params=params)
print(response.json())
```

### Truto TS SDK

```typescript
import Truto from '@truto/truto-ts-sdk';

const truto = new Truto({
  token: '<your_api_token>',
});

const result = await truto.unifiedApi.list(
  'ads',
  'campaigns',
  { integrated_account_id: '<integrated_account_id>' }
);

console.log(result);
```

### Truto Python SDK

```python
import asyncio
from truto_python_sdk import TrutoApi

truto_api = TrutoApi(token="<your_api_token>")

async def main():
    async for item in truto_api.unified_api.list(
        "ads",
        "campaigns",
        {"integrated_account_id": "<integrated_account_id>"}
    ):
        print(item)

asyncio.run(main())
```
